<!doctype html>
<!--
    Copyright (c) 2010, 2025 Contributors to the Eclipse Foundation

    See the NOTICE file(s) distributed with this work for additional
    information regarding copyright ownership.

    This program and the accompanying materials are made available under the terms
    of the MIT License which is available at https://opensource.org/licenses/MIT

    SPDX-License-Identifier: MIT
-->
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Module 5.3 | SBE Course</title>
        <link rel="icon" type="image/png" href="../sbe-course-favicon.png"/>

        <!-- Bootstrap. -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.6.0/font/bootstrap-icons.css" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>

        <!-- Website styling. -->
        <link rel="stylesheet" href="../../assets/eclipse-escet.css">
        <link rel="stylesheet" href="../../assets/eclipse-escet-sbe-course.css">

        <!-- Version selector. -->
        <script src="../../assets/eclipse-escet.js"></script>

        <!-- Code block syntax highlighting. -->
        <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css">
        <script src="../../assets/highlight.min.js"></script>
        <script src="../../assets/languages/cif.min.js"></script>
        <script src="../../assets/languages/tooldef.min.js"></script>

        <!-- Quiz. -->
        <link rel="stylesheet" href="../assets/quiz.css">
        <script src="../assets/quiz.js"></script>

        <!-- SBE course. -->
        <link rel="stylesheet" href="../assets/course.css">
        <script src="../assets/course.js"></script>
    </head>

    <body class="escet-dark">

        <!-- Top navigation bar -->
        <nav class="navbar navbar-expand-lg navbar-dark escet-bg">
            <div class="container-fluid">
                <a class="navbar-brand d-lg-none">SBE Course</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-0 mb-lg-0">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle escet-brand px-0" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">Eclipse ESCET™ / SBE Course</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <li><a class="dropdown-item" href="../.."><img src="../../eclipse-escet-favicon.png" class="pe-2"> Eclipse ESCET / Project</a></li>
                                <li><a class="dropdown-item" href=".."><img src="../sbe-course-favicon.png" class="pe-2"> Eclipse ESCET / SBE Course</a></li>
                                <li><a class="dropdown-item" href="../../cif"><img src="../../cif/cif-favicon.png" class="pe-2"> Eclipse ESCET / CIF</a></li>
                                <li><a class="dropdown-item" href="../../chi"><img src="../../chi/chi-favicon.png" class="pe-2"> Eclipse ESCET / Chi</a></li>
                                <li><a class="dropdown-item" href="../../tooldef"><img src="../../tooldef/tooldef-favicon.png" class="pe-2"> Eclipse ESCET / ToolDef</a></li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="../" aria-expanded="false">Home</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown1" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 1</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown1">
                                <li><a class="dropdown-item" href="../module1">Module 1: Supervisory control of discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/supervisory-control.html">Module 1.1: Supervisory control</a></li>
                                <li><a class="dropdown-item" href="../module1/discrete-event-systems.html">Module 1.2: Discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/modeling-discrete-event-systems.html">Module 1.3: Modeling discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/get-started-with-cif.html">Module 1.4: Get started with CIF</a></li>
                                <li><a class="dropdown-item" href="../module1/exercises.html">Module 1.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module1/introduction-to-the-water-lock-case.html">Module 1.6: Introduction to the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown2" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 2</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown2">
                                <li><a class="dropdown-item" href="../module2">Module 2: Working with automata</a></li>
                                <li><a class="dropdown-item" href="../module2/reachability-deadlock-blocking-livelock.html">Module 2.1: Reachability, deadlock, blocking and livelock</a></li>
                                <li><a class="dropdown-item" href="../module2/non-deterministic-automata.html">Module 2.2: Non-deterministic automata</a></li>
                                <li><a class="dropdown-item" href="../module2/synchronizing-automata.html">Module 2.3: Synchronizing automata</a></li>
                                <li><a class="dropdown-item" href="../module2/shared-variables.html">Module 2.4: Shared variables</a></li>
                                <li><a class="dropdown-item" href="../module2/computing-state-spaces.html">Module 2.5: Computing state spaces</a></li>
                                <li><a class="dropdown-item" href="../module2/cif-tools-view-analyze-models.html">Module 2.6: CIF tools to view and analyze models</a></li>
                                <li><a class="dropdown-item" href="../module2/constants-and-algebraic-variables.html">Module 2.7: Constants and algebraic variables</a></li>
                                <li><a class="dropdown-item" href="../module2/exercises.html">Module 2.8: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module2/more-detailed-models-water-lock-case.html">Module 2.9: More detailed models for the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown3" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 3</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown3">
                                <li><a class="dropdown-item" href="../module3">Module 3: Supervisory control and plant models</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-control-loop.html">Module 3.1: Supervisory control loop</a></li>
                                <li><a class="dropdown-item" href="../module3/synthesis-guarantees.html">Module 3.2: Synthesis guarantees</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-controller-synthesis.html">Module 3.3: Supervisory controller synthesis</a></li>
                                <li><a class="dropdown-item" href="../module3/modeling-larger-systems.html">Module 3.4: Modeling larger systems</a></li>
                                <li><a class="dropdown-item" href="../module3/exercises.html">Module 3.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module3/water-lock-case-plant-models.html">Module 3.6: Water lock case plant models</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown4" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 4</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown4">
                                <li><a class="dropdown-item" href="../module4">Module 4: Modeling requirements and supervisor synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/user-specified-requirements.html">Module 4.1: User-specified requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/requirement-automata-and-invariants.html">Module 4.2: Requirements automata and invariants</a></li>
                                <li><a class="dropdown-item" href="../module4/synthesis-with-requirements.html">Module 4.3: Synthesis with requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/modeling-for-synthesis.html">Module 4.4: Modeling for synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/performing-synthesis-with-cif.html">Module 4.5: Performing synthesis with CIF</a></li>
                                <li><a class="dropdown-item" href="../module4/introduction-to-svg-visualization.html">Module 4.6: Introduction to SVG visualization</a></li>
                                <li><a class="dropdown-item" href="../module4/exercises.html">Module 4.7: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module4/water-lock-case-requirements-and-supervisor.html">Module 4.8: Water lock case requirements and supervisor</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle active" aria-current="page" href="#" id="navbarDropdown5" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 5</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown5">
                                <li><a class="dropdown-item" href="./">Module 5: Hybrid simulation models</a></li>
                                <li><a class="dropdown-item" href="timed-and-hybrid-models.html">Module 5.1: Timed and hybrid models</a></li>
                                <li><a class="dropdown-item" href="variable-time.html">Module 5.2: Variable 'time'</a></li>
                                <li><a class="dropdown-item active" aria-current="page" href="continuous-variables.html">Module 5.3: Continuous variables</a></li>
                                <li><a class="dropdown-item" href="urgency.html">Module 5.4: Urgency</a></li>
                                <li><a class="dropdown-item" href="tau-event.html">Module 5.5: The 'tau' event</a></li>
                                <li><a class="dropdown-item" href="exercises.html">Module 5.6: Exercises</a></li>
                                <li><a class="dropdown-item" href="water-lock-case-hybrid-model.html">Module 5.7: Water lock case hybrid model</a></li>
                                <li><a class="dropdown-item" href="course-conclusion.html">Module 5.8: Course conclusion</a></li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <!-- Intro -->
        <div id="intro" class="position-relative p-3 text-center escet-bg escet-bg-opacity-125">
            <div class="clearfix mb-4 mb-md-0">
                <span class="float-end">
                    Version:
                    <div class="dropdown d-inline-block">
                        <a class="dropdown-toggle" href="#" role="button" id="versionDropdown" data-bs-toggle="dropdown" aria-expanded="false">v7.0-M1</a>
                        <ul id="versions-dropdown" class="dropdown-menu dropdown-menu-end" aria-labelledby="versionDropdown" data-this-version="/v7.0-M1">
                            <li><h6 id="versions-previews" class="dropdown-header">Previews</h6></li>
                            <li><h6 id="versions-latest-releases" class="dropdown-header">Latest releases</h6></li>
                            <li><h6 class="dropdown-header">Other</h6></li>
                            <li><a class="dropdown-item" href="../../versions.html">All versions...</a></li>
                        </ul>
                    </div>
                    <a class="text-nowrap ms-3" href="../../release-notes.html">[release notes]</a>
                </span>
            </div>
        </div>

        <!-- Content -->
        <div class="px-4 pt-5">
            <div class="row justify-content-center">
                <div class="col-12 col-md-10 col-xl-8 col-xxl-6" id="content">

                    <h1>Module 5.3: Continuous variables</h1>
                    <p>
                        Variable <code>time</code> tracks the <em>absolute</em> time that has passed in a model, since the initial state.
                        However, often it is more convenient to use <em>relative</em> time.
                        Relative time is the time that has passed since a certain moment in time, for example the time that has passed since the last occurrence of a certain event.
                        To measure relative time, CIF features <em>continuous variables</em>.
                        Continuous variables can however also be used to represent other continuously changing values, such as temperature, water levels, positions of moving objects, and so on.
                    </p>
                    <p>
                        Just like variable <code>time</code>, continuous variables change automatically as time progresses.
                        However, there are differences.
                        Continuous variables can also be assigned a new value on edges, like discrete variables, allowing for instance to reset them to zero.
                        In addition, continuous variables can be initialized to any value, like discrete variables.
                        Furthermore, the rate of change of the value of a continuous variable per time unit (that is, its <em>derivative</em> measured in seconds) can be different for every continuous variable.
                        If a continuous variable has a derivative of one, either positive or negative, it is also called a <em>timer</em>.
                    </p>
                    <p>
                        The following CIF model shows an example of a continuous variable (more specifically, a timer), to model a lamp that is turned off five seconds after it is turned on:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            automaton lamp:
                                event turn_on, turn_off;
                                cont t = 0 der 1;

                                location Off:
                                    initial;
                                    marked;
                                    edge turn_on do t := 0 goto On;

                                location On:
                                    edge turn_off when t &gt;= 5 goto Off;
                            end
                        </code>
                    </pre>
                    <p>
                        The automaton models a lamp that can be turned on and off.
                        Continuous variable <code>t</code> is declared in the automaton.
                        It has initial value <code>0</code> and its derivative is <code>1</code>.
                        It thus starts at value <code>0</code>, and every second it grows by <code>1</code>.
                        It is thus <code>1</code> after one second, <code>2</code> after two seconds, <code>2.5</code> after 2.5 seconds, and so on.
                        Whenever event <code>turn_on</code> occurs, <code>t</code> is reset to zero, and time thus starts to be measured again from zero.
                        The lamp is turned off only after <code>5</code> seconds have passed.
                        When the lamp is turned on again, <code>t</code> is reset again, and time starts to measure from zero.
                        So, the lamp is always turned off after having been on for 5 seconds.
                    </p>
                    <p>
                        Using a continuous variable is much easier than using variable <code>time</code> in this case.
                        There is no need to separately account for 5, 10, 15, and so on seconds of time that have passed.
                        Since there are infinitely many such times, they can't be listed individually.
                        It would be possible to store the current time in a discrete variable when the lamp is turned on, and compare the current time against that variable, to see if five seconds have passed:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            automaton lamp:
                                event turn_on, turn_off;
                                disc real start_time;

                                location Off:
                                    initial;
                                    marked;
                                    edge turn_on do start_time := time goto On;

                                location On:
                                    edge turn_off when time - start_time >= 5 goto Off;
                            end
                        </code>
                    </pre>
                    <p>
                        However, using a continuous variable leads to a simpler model, that more directly expresses our intent.
                        We measure the relative time from the moment that the lamp is turned on in <code>t</code>, and check whether 5 seconds have passed using guard <code>t &gt;= 5</code>.
                    </p>
                    <p>
                        Just as integer discrete variables have initial value zero if its not explicitly specified, so do continuous variables.
                        The declaration of <code>t</code> can thus also be written as follows:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            cont t der 1;
                        </code>
                    </pre>
                    <p>
                        Continuous variables may be declared in automata.
                        Just as with discrete variables, only the automaton that declares the variable can assign it a new value.
                        However, continuous variables may also be declared outside automata.
                        They can then still be given an initial value and derivative, but they cannot be reset on edges.
                    </p>

                    <h2>Specifying derivatives</h2>
                    <p id="phone-model">
                        So far, we've specified the derivative of the continuous variable with its declaration.
                        However, there are alternatives.
                        We'll explore these alternatives using an example of a mobile phone:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            automaton phone:
                                event charge;
                                cont t = 0 der 1;

                                location:
                                    initial;
                                    marked;
                                    edge charge when t >= 100 do t := 0;
                            end
                        </code>
                    </pre>
                    <p>
                        We'll consider a time unit to be a minute here.
                        The phone can then be used for 100 minutes, after which it needs to be charged.
                        It can then again be used for 100 minutes, before it needs to be charged again.
                        The continuous variable again has its derivative defined with its declaration.
                    </p>
                    <p>
                        The derivative may alternatively be specified separately from the declaration of the continuous variable, using an <em>equation</em>:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            automaton phone:
                                event charge;

                                cont t = 0;
                                equation t' = 1;

                                location:
                                    initial;
                                    marked;
                                    edge charge when t >= 100 do t := 0;
                            end
                        </code>
                    </pre>
                    <p>
                        The continuous variable is still declared in the automata, and still given an initial value of <code>0</code>.
                        However, its derivative is now specified by an equation.
                        The equation <code>t' = 1</code> indicates that the derivative of <code>t</code>, denoted by <code>t'</code>, is <code>1</code>.
                        An equation for a continuous variable must be specified in the same component as where the continuous variable is declared.
                        So, if a continuous variable is declared in an automaton, the equation must be in the same automaton.
                        If a continuous variable is declared in a group, the equation must be in the same group.
                        And if the continuous variable is declared outside the automata and groups, then the equation must be specified there as well.
                        Separating the specification of the derivative from the declaration of the continuous variable can be useful for larger models.
                    </p>
                    <p>
                        This model is still a somewhat simplified version of reality, since the phone can be charged instantaneously.
                        We can use the same continuous variable to measure the time that the phone can be used (100 minutes) and that it has to charge (10 minutes):
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            automaton phone:
                                event charge, use;

                                cont t = 0;
                                equation t' = 1;

                                location Using:
                                    initial;
                                    marked;
                                    edge charge when t >= 100 do t := 0 goto Charging;

                                location Charging:
                                    edge use    when t >= 10  do t := 0 goto Using;
                            end
                        </code>
                    </pre>
                    <p>
                        The automaton is extended to two locations, to track whether the owner is using the phone, or it is charging.
                        After 100 minutes of using the phone, it needs to be charged, as indicated by the <code>charge</code> event occurring and the automaton going to the <code>Charging</code> location.
                        After 10 minutes of charging, the phone can be used again, as indicated by the <code>use</code> event occurring and the automaton going to the <code>Using</code> location.
                    </p>
                    <p>
                        In reality, phones typically track the battery percentage, rather than measuring the time to the next charge.
                        Let's assume the battery percentage drops by 1.5% per minute when the phone is being used, and it increases by 7% per minute when the phone is being charged.
                        We can model the battery percentage using a continuous variable, and by specifying its derivative per location:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            automaton phone:
                                event charge, use;
                                cont battery_percentage = 100;

                                location Using:
                                    initial;
                                    marked;
                                    equation battery_percentage' = -1.5;
                                    edge charge when battery_percentage <   10 goto Charging;

                                location Charging:
                                    equation battery_percentage' = 7;
                                    edge use    when battery_percentage >= 100 goto Using;
                            end
                        </code>
                    </pre>
                    <p>
                        The phone is initially fully charged, as indicated by its initial value of <code>100</code> percent.
                        While the phone is being used, every minute the battery percentage drops by <code>1.5</code> percent, as specified by the equation in location <code>Using</code>.
                        Once the phone's battery percentage drops under <code>10</code> percent, the phone is charged.
                        Charging increases the battery percentage by <code>7</code> percent every minute.
                        Once it is fully charged, it can be used again.
                        By using an equation per location, we can make the battery percentage increase in one location and decrease in the other.
                        We can also make it increase or decrease at different rates.
                    </p>
                    <p>
                        The derivative of a continuous variable may only be specified using equations per location, if the continuous variable itself is specified in that same automaton.
                        An equation must then be present in every location.
                        An equation may also specify that the derivative is zero, meaning that the continuous variable does not change its value while being in that location.
                    </p>
                    <p>
                        There are thus three ways to specify the derivative of a continuous variable: with its declaration, using a single equation, or using an equation per location of the automaton.
                    </p>
                    <p>
                        The model that specifies an equation per location can also be rewritten to use a single equation, by making use of an <code>if</code> expression:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            automaton phone:
                                event charge, use;
                                cont battery_percentage = 100;
                                equation battery_percentage' = if Using: -1.5 else 7 end;

                                location Using:
                                    initial;
                                    marked;
                                    edge charge when battery_percentage <   10 goto Charging;

                                location Charging:
                                    edge use    when battery_percentage >= 100 goto Using;
                            end
                        </code>
                    </pre>
                    <p>
                        This brings the different values of the derivative closer together, which is especially useful if there are many locations and the values becomes a bit scattered throughout the model.
                        The equation can also be written using a <code>switch</code> expression, which is slightly nicer in this case, as it makes the locations more explicit:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            automaton phone:
                                event charge, use;
                                cont battery_percentage = 100;
                                equation battery_percentage' = switch phone:
                                                                   case Using:    -1.5
                                                                   case Charging:  7
                                                               end;

                                location Using:
                                    initial;
                                    marked;
                                    edge charge when battery_percentage <   10 goto Charging;

                                location Charging:
                                    edge use    when battery_percentage >= 100 goto Using;
                            end
                        </code>
                    </pre>
                    <p>
                        The <code>switch</code> expression has different cases, and for each case it can give a different value.
                        In this case, it switches over automaton <code>phone</code>, meaning it switches over the locations of that automaton.
                        Per location, it then indicates the derivative value.
                        Since this <code>switch</code> expression is used inside the <code>phone</code> automaton, we can also use keyword <code>self</code> instead of the automaton name:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-cif hljs" data-lang="cif">
                            equation battery_percentage' = switch self:
                                                               case Using:    -1.5
                                                               case Charging:  7
                                                           end;
                        </code>
                    </pre>
                    <p>
                        Using <code>self</code> makes it easier to later change the automaton name.
                    </p>
                    <p>
                        This model is still somewhat unrealistic, as there is no way to use the phone for only half an hour, or charge it for only a minute.
                        We'll revisit this in the next sub-module.
                    </p>

                    <h2>CIF simulator's plot visualizer</h2>
                    <p>
                        When simulating models with timed behavior, the CIF simulator's state visualizer will also show the value of variable <code>time</code> and each continuous variable.
                        However, it only shows the values for the current state (that is, only the value that it has at the current time).
                        When dealing with timed behavior, it can be very useful to see the values of the variables as they change over time.
                        The CIF simulator features a plot visualizer for that.
                        It displays a graph of the values of the variables over time.
                        It can be enabled in a similar way as the state visualizer.
                    </p>
                    <p>
                        If we simulate the lamp that is only on for 5 seconds (see top of this page) for 40 time units, the plot visualizer shows:
                    </p>
                    <img src="images/plot-visualizer-example.png">
                    <p>
                        We see the value of continuous variable <code>lamp.t</code> over time, but also that of its derivative <code>lamp.t'</code>.
                    </p>

                    <h2>Quiz</h2>
                    <div class="quiz">
                        [
                            {
                                type: 'multiple-choice',
                                question: "Which statements are true about derivatives of continuous variables?",
                                answers: [
                                    "The derivative of a continuous variable is by default <code>1</code>.",
                                    "The derivative of a continuous variable must have a value in every situation.",
                                    "The derivative of a continuous variable must be specified in every location of the automaton."
                                ],
                                correctAnswer: '2'
                            },
                            {
                                type: 'single-choice',
                                question: "What is the difference between a discrete variable and a continuous variable?",
                                answers: [
                                    "A continuous variable can change over time, whereas a discrete variable can't change value without explicitly being assigned.",
                                    "A discrete variable can be assigned a value, whereas a continuous variable changes value due to its derivative.",
                                    "Discrete variables can have both positive and negative values, whereas a continuous variable can only have positive values."
                                ],
                                correctAnswer: '1'
                            },
                            {
                                type: 'single-choice',
                                question: "Is the implicitly always present variable <code>time</code> essentially a timer that starts at <code>0</code>, every time unit increases by <code>1</code>, and is never reset?",
                                answers: [
                                    "Yes.",
                                    "No.",
                                ],
                                correctAnswer: '1'
                            }
                        ];
                    </div>

                    <div class="course-navigation-footer">
                        <div class="course-navigation-prev"><a href="variable-time.html">Go back to Module 5.2</a></div>
                        <div class="course-navigation-separator">|</div>
                        <div class="course-navigation-next"><a href="urgency.html">Proceed to Module 5.4</a></div>
                    </div>

                </div>
            </div>
        </div>

        <!-- Footer -->
        <div class="container" id="footer">
            <footer class="pt-3 mt-4">
                <ul class="nav justify-content-center border-top pb-1 mb-1">
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org">Eclipse Home</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/privacy.php">Eclipse Privacy Policy</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/termsofuse.php">Eclipse Terms of Use</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/copyright.php">Eclipse Copyright Agent</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal">Eclipse Legal</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.dev/escet/legal.html">Eclipse ESCET Legal</a></li>
                </ul>
                <p class="text-center text-muted">Copyright © 2010, 2025 Contributors to the Eclipse Foundation</p>
            </footer>
        </div>

    </body>
</html>
